Preview URL in Wiki Toolbar should be escaped

2019-02-06 19:15 - Vincent Robert

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Wiki Estimated time: 0.00 hour

Target version: 4.0.2   

Resolution: Fixed Affected version: 4.0.1

Description

Since Redmine 4.0.0 and the addition of the preview tab, the wiki toolbar is not displayed if the preview url contains single quotes.

The url is not escaped and we can see an error in our browser console.

We should escape the preview url:

diff --git a/lib/redmine/wiki_formatting/markdown/helper.rb b/lib/redmine/wiki_formatting/markdown

/helper.rb

index fac2f8bf3..fb9f1a939 100644

--- a/lib/redmine/wiki_formatting/markdown/helper.rb

+++ b/lib/redmine/wiki_formatting/markdown/helper.rb

@@ -22,7 +22,7 @@ module Redmine

         def wikitoolbar_for(field_id, preview_url = preview_text_path)

           heads_for_wiki_formatter

           url = "#{Redmine::Utils.relative_url_root}/help/#{current_language.to_s.downcase}/wiki_

syntax_markdown.html" 

-          javascript_tag("var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}'))

; wikiToolbar.setHelpLink('#{escape_javascript url}'); wikiToolbar.setPreviewUrl('#{preview_url}')

; wikiToolbar.draw();")

+          javascript_tag("var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}'))

; wikiToolbar.setHelpLink('#{escape_javascript url}'); wikiToolbar.setPreviewUrl('#{escape_javascr

ipt preview_url}'); wikiToolbar.draw();")

         end

         def initial_page_content(page)

diff --git a/lib/redmine/wiki_formatting/textile/helper.rb b/lib/redmine/wiki_formatting/textile/h

elper.rb

index 6e8ba9812..e536a29dc 100644

--- a/lib/redmine/wiki_formatting/textile/helper.rb

+++ b/lib/redmine/wiki_formatting/textile/helper.rb

@@ -23,7 +23,7 @@ module Redmine

           heads_for_wiki_formatter

           # Is there a simple way to link to a public resource?

           url = "#{Redmine::Utils.relative_url_root}/help/#{current_language.to_s.downcase}/wiki_

syntax_textile.html" 

-          javascript_tag("var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}'))

; wikiToolbar.setHelpLink('#{escape_javascript url}'); wikiToolbar.setPreviewUrl('#{preview_url}')

; wikiToolbar.draw();")

+          javascript_tag("var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}'))

; wikiToolbar.setHelpLink('#{escape_javascript url}'); wikiToolbar.setPreviewUrl('#{escape_javascr

ipt preview_url}'); wikiToolbar.draw();")

         end

         def initial_page_content(page)

Related issues:

Related to Redmine - Feature #27758: Adds preview option to the wiki toolbar Closed

Associated revisions

Revision 17856 - 2019-02-11 16:55 - Go MAEDA

Preview URL in Wiki Toolbar should be escaped (#30758).
Patch by Vincent Robert.

Revision 17857 - 2019-02-11 16:57 - Go MAEDA

Merged r17856 from trunk to 4.0-stable (#30758).

History

#1 - 2019-02-06 22:44 - Go MAEDA

- Status changed from New to Needs feedback

Thank you for the patch. Could you paste some example URLs that reproduce the problem?

#2 - 2019-02-06 22:51 - Vincent Robert

Here is an example. The last link will lead to a form where the wikitoolbar is missing.

h1. CookBook documentation

{{child_pages}}

Some updated [[documentation]] here with gzipped history

{{toc}}

* [[Installation]]

* [[Rock'n Roll]]

#3 - 2019-02-06 23:02 - Go MAEDA

Vincent Robert wrote:

Here is an example. The last link will lead to a form where the wikitoolbar is missing.

[...]

 Thank you. But it does not break the toolbar in my environment. Could you paste a screenshot that shows the problem? Sorry for bothering you again

and again.

#4 - 2019-02-07 08:20 - Vincent Robert

- File screenshot.png added

Here it is:

 screenshot.png 

#5 - 2019-02-08 09:43 - Go MAEDA

- Status changed from Needs feedback to Confirmed

#6 - 2019-02-08 10:23 - Go MAEDA

- Target version set to 4.0.2

Setting the target version to 4.0.2.

#7 - 2019-02-11 16:58 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for detecting and fixing this issue.

#8 - 2019-02-11 17:17 - Vincent Robert

Thanks.

How could we associate this kind of patch with our Github account?

I think more contributors would be motivated if they could get credit in Github.
#9 - 2019-02-12 00:17 - Marius BĂLTEANU

Thanks Vincent for reporting and fixing this issue.

Vincent Robert wrote:

How could we associate this kind of patch with our Github account?

I think more contributors would be motivated if they could get credit in Github.

 I don't think that it is possible mostly because of the SVN.

#10 - 2019-04-02 07:56 - Marius BĂLTEANU

- Related to Feature #27758: Adds preview option to the wiki toolbar added

Files

escape_preview_url.diff 1.99 KB 2019-02-06 Vincent Robert

screenshot.png 207 KB 2019-02-07 Vincent Robert
